local table = require("hp/lang/table")
local class = require("hp/lang/class")

--------------------------------------------------------------------------------
-- ダンジョンの領域です.
-- @class table
-- @name DungeonRange
--------------------------------------------------------------------------------
local M = class()

M.DIR_HORIZONAL = 1
M.DIR_VERTICAL = 2

--------------------------------------------------------------------------------
-- コンストラクタです.
--------------------------------------------------------------------------------
function M:init(x, y, width, height)
    self.x = x
    self.y = y
    self.width = width
    self.height = height
end

--------------------------------------------------------------------------------
-- 指定した座標が衝突するか返します.
--------------------------------------------------------------------------------
function M:collisionAt(x, y)
    return self.x <= x and x < self.x + self.width
       and self.y <= y and y < self.y + self.height
end

--------------------------------------------------------------------------------
-- ダンジョン上での型を返します.
--------------------------------------------------------------------------------
function M:getType()
    return "Room"
end

return M