local table = require("hp/lang/table")
local class = require("hp/lang/class")

--------------------------------------------------------------------------------
-- ダンジョンの道です.
-- @class table
-- @name DungeonRoad
--------------------------------------------------------------------------------
local M = class()

--------------------------------------------------------------------------------
-- コンストラクタです.
--------------------------------------------------------------------------------
function M:init()
    self.width = 1
    self.height = 1
    self.x = 1
    self.y = 1
end

--------------------------------------------------------------------------------
-- 指定した座標が衝突するか返します.
--------------------------------------------------------------------------------
function M:collisionAt(x, y)
    return self.x <= x and x < self.x + self.width
       and self.y <= y and y < self.y + self.height
end

--------------------------------------------------------------------------------
-- ダンジョン上での型を返します.
--------------------------------------------------------------------------------
function M:getType()
    return "Road"
end

return M